unit ExtUnit;
{
Copyright (C) 2005 Patrick Chevalley

http://www.astrosurf.com/astropc
pch@freesurf.ch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses  FileCtrl, Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, OleCtnrs, blcksock, HTTPsend, FTPSend,
  HiResTim;

type
  TExtForm = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    BitBtn3: TBitBtn;
    Panel1: TPanel;
    Label5: TLabel;
    msg: TEdit;
    Memo1: TMemo;
    Timer1: THiResTimer;
    procedure FormShow(Sender: TObject);
    procedure SockStatus(Sender: TObject; Reason: THookSocketReason; Const Value: string) ;
    procedure BitBtn2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FTPStatus(Sender: TObject; Response: Boolean; Const Value: string);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure HttpError;
    procedure HttpSuccess;
    procedure FTPSuccess;
    procedure FTPError;
  end;

procedure GetExt(res,eurl,emethode,einfo,filename : string);
Procedure ModUrl(pattern,buf : string);

var
  ExtForm: TExtForm;
  http: THTTPSend;
  ftp : TFTPSend;

implementation

uses variables1, detail1;

var  InfoUrl,url,method,proxy,proxyport,proxyuser,proxypass,fname,infomsg,ftpfile,ftpdir,ftptmp : string;
     FWPassive : boolean;
     FWHost,FWPort,FWUsername,FWPassword:string;
     nl,sockreadcount,sockwritecount,FWMode : integer;

{$R *.DFM}

Function GetTempFile(i : integer) : String;
var N, P :String;
begin
  Result:='';
  SetLength( P, MAX_PATH );
  SetLength( P, GetTempPath( MAX_PATH, PChar( P ) ) );
  SetLength( N, MAX_PATH );
  if ( GetTempFileName( PChar( P ), '~ci', i, PChar( N ) ) = 0 )
    then begin ShowMessage('Cannot assign temporary file');exit;end;
  SetLength( N, lstrlen( PChar( N ) ) );
  Result := N;
end;

procedure GetExt(res,eurl,emethode,einfo,filename : string);
var inifile : Tinifile;
begin
Extform.Label4.Caption:=res;
fname:=filename;
url:=eurl;
method:=emethode;
InfoUrl:=einfo;
inifile:=Tinifile.create('.\extres.ini');
with inifile do begin
proxy:=ReadString('proxy','proxy','');
proxyport:=ReadString('proxy','proxyport','');
proxyuser:=ReadString('proxy','proxyuser','');
proxypass:=ReadString('proxy','proxypass','');
FWmode:=ReadInteger('ftp_firewall','mode',0);
FWPassive:=ReadBool('ftp_firewall','passv',true);
FWHost:=ReadString('ftp_firewall','host','');
FWPort:=ReadString('ftp_firewall','port','');
FWUsername:=ReadString('ftp_firewall','user','');
FWPassword:=ReadString('ftp_firewall','pass','');
end;
inifile.free;
if InfoUrl='' then Extform.Label5.Caption:=''
              else Extform.Label5.Caption:=infomsg+' '+InfoUrl;
end;

Procedure ModUrl(pattern,buf : string);
var i,l : integer;
begin
i:=pos(pattern,url);
l:=length(pattern);
if i>0 then begin
  url:=copy(url,1,i-1)+buf+copy(url,i+l,99999);
end;

end;

procedure TExtForm.HttpError;
begin
edit3.Text:=edit3.text+' / Error: '+inttostr(http.ResultCode)+' '+http.ResultString;
end;

procedure TExtForm.HttpSuccess;
var c : char;
    i : integer;
    line : string;
    f : textfile;
begin
 line:='';
 nl:=0;
 assignfile(f,fname);
 rewrite(f);
 if Extform.Label4.Caption='AAVSO QuickLook' then begin
   http.Document.Position:=0;
   repeat
     i:=http.Document.Read(c,1);
     if i=1 then begin
     case c of
      #13  : continue;
      #10  : begin
             //if ((stardesign<>'')and(trim(copy(line,1,9))=stardesign))or
             //   ((stardesign='')and(trim(copy(line,10,10))=uppercase(starname)))
             stringreplace(line,'</b>','',[]);
             if trim(copy(line,1,10))=uppercase(starname)
             then begin
                inc(nl);
                writeln(f,line);
             end;
             line:='';
             end;
      else line:=line+c;
     end;
     end;
   until i=0;
 end else if Extform.Label4.Caption='VSNET data browser' then begin
   http.Document.Position:=0;
   repeat
     i:=http.Document.Read(c,1);
     if i=1 then begin
     case c of
      #13  : continue;
      #10  : begin
             if (trim(words(line,'',1,1))=vsname)
             then begin
                inc(nl);
                writeln(f,line);
             end;
             line:='';
             end;
      else line:=line+c;
     end;
     end;
   until i=0;
 end;
 CloseFile(f);
 Edit3.text:=edit3.text+(' Ended. Lines/Block read = '+inttostr(nl));
 if nl=0 then Edit3.text:=edit3.text+'  No data for this star !';
 BitBtn1.Visible:=true;
 BitBtn2.Visible:=false;
end;

procedure TExtForm.FormShow(Sender: TObject);
begin
memo1.Clear;
memo1.Visible:=false;
BitBtn1.Visible:=false;
BitBtn2.Visible:=true;
BitBtn3.Visible:=true;
edit1.text:=url;
edit2.text:=fname;
edit3.Text:='';
nl:=0;
end;


procedure TExtForm.SockStatus(Sender: TObject; Reason: THookSocketReason; Const Value: string) ;
var reasontxt:string;
begin
case reason of
HR_ResolvingBegin : reasontxt:='Resolving '+value;
HR_Connect        : reasontxt:='Connect '+value;
HR_Accept         : reasontxt:='Accept '+value;
HR_ReadCount      : begin
                    Sockreadcount:=Sockreadcount+strtoint(value);
                    reasontxt:='Read Bytes: '+inttostr(Sockreadcount);
                    end;
HR_WriteCount     : begin
                    Sockwritecount:=Sockwritecount+strtoint(value);
                    reasontxt:='Request sent, waiting response';
                    end;
else reasontxt:='';
end;
if reasontxt>'' then begin
  edit3.text:=reasontxt;
  edit3.refresh;
end;
end;

procedure TExtForm.BitBtn2Click(Sender: TObject);
begin                
if copy(url,1,4)='http' then http.Sock.CloseSocket
                        else ftp.abort;
 BitBtn1.Visible:=true;
 BitBtn2.Visible:=false;
 Application.processmessages;
//   ExtForm.Close;
end;

procedure TExtForm.Timer1Timer(Sender: TObject);
var buf : string;
    i : integer;
    ok:boolean;
begin
timer1.enabled:=false;
if copy(url,1,4)='http' then begin        // HTTP protocol
http.Clear;
http.Timeout:=300000;
sockreadcount:=0;
sockwritecount:=0;
if proxy<>'' then http.ProxyHost:=proxy;
if proxyport<>'' then http.ProxyPort:=proxyport;
if proxyuser<>'' then http.ProxyUser :=proxyuser;
if proxypass<>'' then http.ProxyPass :=proxypass;
http.Sock.OnStatus:=SockStatus;
try
  if http.HTTPMethod(Method, url)
     and ((http.ResultCode=200)
       or (http.ResultCode=0))
     then httpsuccess
     else httperror;
  http.Clear;
except
http.Clear;
end;
end else begin                // FTP protocol
if copy(url,1,3)<>'ftp' then exit;
i:=pos('://',url);
buf:=copy(url,i+3,999);
i:=pos('/',buf);
ftp.Targethost:=copy(buf,1,i-1);
ftp.PassiveMode:=FWpassive;
ftp.FWMode:=FWMode;
if FWhost<>'' then ftp.FWHost:=FWHost;
if FWport<>'' then ftp.FWPort:=FWPort;
if FWUsername<>'' then ftp.FWUsername:=FWUsername;
if FWPassword<>'' then ftp.FWPassword:=FWPassword;
ftp.OnStatus:=ftpstatus;
sockreadcount:=0;
sockwritecount:=0;
ftp.Sock.OnStatus:=SockStatus;
buf:=copy(buf,i,999);
i:=LastDelimiter('/',buf);
ftpdir:=copy(buf,1,i);
ftpfile:=copy(buf,i+1,999);
ftptmp:=gettempfile(123);
deletefile(ftptmp);
if ftp.Login then begin
  ftp.ChangeWorkingDir(ftpdir);
  ftp.DirectFile:=true;
  ftp.DirectFileName:=ftptmp;
  ok:=ftp.RetrieveFile(ftpfile,false);
  ftp.logout;
  if ok then FtpSuccess
        else ftperror;
end;
end;
if memo1.Text<>'' then begin
   memo1.Visible:=true;
   memo1.BringToFront;
end;   
end;

procedure TExtForm.FormCreate(Sender: TObject);
begin
http := THTTPSend.Create;
ftp := TFTPSend.Create;
end;

procedure TExtForm.BitBtn3Click(Sender: TObject);
var buf : string;
begin
edit3.text:='Request data from the server';
//if (ExtractFileExt(edit2.text)='.')or(ExtractFileExt(edit2.text)='') then edit2.text:=ChangeFileExt(edit2.text,'.cat');
fname:=edit2.text;
buf:=ExtractFilepath(fname);
if not directoryexists(buf) then forcedirectories(buf);
extform.refresh;
Timer1.enabled:=true;
BitBtn3.Visible:=false;
end;

procedure TExtForm.Panel1Click(Sender: TObject);
begin
if infourl>'' then ExecuteFile(InfoUrl, '', '', SW_SHOWNOACTIVATE);
end;

procedure TExtForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
msg.text:='';
end;

procedure TExtForm.ftpError;
begin
edit3.Text:=edit3.text+' / Error: '+inttostr(ftp.ResultCode)+' '+ftp.ResultString;
end;

procedure TExtForm.FTPSuccess;
var i,j : integer;
    f1:file;
    f : textfile;
    buf : array[0..4095]of char;
    wbuf,line : string;
    lf : char;
begin
nl:=0;
   lf:=chr(10);
   assignfile(f1,ftptmp);
   reset(f1,1);
   assignfile(f,fname);
   rewrite(f);
   wbuf:='';
   repeat
       blockread(f1,buf,sizeof(buf),i);
       wbuf:=wbuf+copy(buf,0,i);
       repeat
         j:=pos(lf,wbuf);
         if j>0 then begin
           line:=copy(wbuf,1,j-1);
           wbuf:=copy(wbuf,j+1,9999);
           writeln(f,line);
           inc(nl);
         end;
       until j=0;
   until eof(f1);
   closefile(f1);
   closefile(f);
   Edit3.text:=edit3.text+(' Ended. Lines/Block read = '+inttostr(nl));
   BitBtn1.Visible:=true;
   BitBtn2.Visible:=false;
end;

procedure TExtForm.FTPStatus(Sender: TObject; Response: Boolean; Const Value: string);
begin
if response then edit3.text:=value;
edit3.refresh;
end;

procedure TExtForm.BitBtn1Click(Sender: TObject);
begin
if nl>0 then modalresult:=mrOK else modalresult:=mrCancel;
end;

procedure TExtForm.FormDestroy(Sender: TObject);
begin
http.Free;
ftp.Free;
end;

end.
