program varobs;
{
Copyright (C) 2005 Patrick Chevalley

http://www.astrosurf.com/astropc
pch@freesurf.ch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

uses
  Windows,
  Forms,
  Registry,
  FileCtrl,
  SysUtils,
  variables1 in 'variables1.pas' {VarForm},
  detail1 in 'detail1.pas' {DetailForm},
  SettingUnit in 'SettingUnit.pas' {OptForm},
  ObsUnit in 'ObsUnit.pas' {ObsForm},
  Sky_DDE_Util in 'Sky_DDE_Util.pas',
  splashunit in 'splashunit.pas' {splash},
  ExtUnit in 'ExtUnit.pas' {ExtForm},
  aavsochart in 'aavsochart.pas' {chartform};

{$R *.RES}

var Registry1: TRegistry;
    appdir,buf : string;
    ok,dirok : boolean;
    f : textfile;
    i : integer;

begin
  appdir:=extractfilepath(paramstr(0));
  Registry1 := TRegistry.Create;       // set install directory
  with Registry1 do begin
    dirok:=false;
    ok:=Openkey('Software\Astro_PC\VarObs',true);
    if ok then begin
      if ValueExists('Install_Dir') then begin
         buf:=ReadString('Install_Dir');
         if buf=appdir then dirok:=true;
      end;
      if not dirok then WriteString('Install_Dir',appdir);
      CloseKey;
    end;
  end;
  Registry1.free;
  chdir(appdir);
 {Attempt to create a named mutex}
  CreateMutex(nil, false, 'AstroPC_VarObs');
 {if it failed then there is another instance}
  if GetLastError = ERROR_ALREADY_EXISTS then begin
   {Send all windows our custom message - only our other}
   {instance will recognise it, and restore itself}
    if paramcount>0 then begin
       assignfile(f,'@@param@@');
       rewrite(f);
       for i:=1 to paramcount do
          writeln(f,paramstr(i));
       Closefile(f);
       sleep(100);
    end;
    SendMessage(HWND_BROADCAST,
                RegisterWindowMessage('AstroPC_VarObs'),
                paramcount,
                0);
   {Lets quit}
    Halt(0);
  end;
  Application.Initialize;
  Application.CreateForm(TVarForm, VarForm);
  Application.CreateForm(TExtForm, ExtForm);
  Application.CreateForm(Tchartform, chartform);
  splash := Tsplash.create(application);
  splash.show;
  splash.refresh;
  Application.CreateForm(TDetailForm, DetailForm);
  Application.CreateForm(TOptForm, OptForm);
  Application.CreateForm(TObsForm, ObsForm);
  Application.Run;
end.
